Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs	(revision 59)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs	(revision 60)
@@ -37,954 +73,1931 @@
         private double m_TaxRate = (CommonMotions.SystemMasterData.ConsumptionTax / 100);
 
         /// <summary>
-        /// 工事基本情報
+        /// 以下、追加分
         /// </summary>
-        private ConstructionBaseInfo m_ConstructionData = new ConstructionBaseInfo();
 
         /// <summary>
-        /// 工事詳細台帳データ
+        /// 請求工事の工事基本情報明細リスト
         /// </summary>
-        private ConstructionLedger m_ConstructionLedger = new ConstructionLedger();
+//        private List<ConstructionBaseInfoDetail> m_BaseConstructionBaseInfoDetail = new List<ConstructionBaseInfoDetail>();
 
+        //private Dictionary<int, ConstructionBaseInfoDetail> m_ConstructionBaseInfoDetail = new Dictionary<int, ConstructionBaseInfoDetail>();
+
         /// <summary>
-        /// 工事基本明細情報
+        /// 請求ヘッダリスト
         /// </summary>
-        private Dictionary<int,string> m_DicConstructionDetail = new Dictionary<int, string>();
+        private List<RequestHead> m_lstRequestHead = new List<RequestHead>();
 
         /// <summary>
-        /// 請求情報
+        /// 請求データリスト
         /// </summary>
-        private RequestData m_RequestData = new RequestData();
+        private List<Dictionary<int, RequestData>> m_lstRequestData = new List<Dictionary<int, RequestData>>();
 
         /// <summary>
-        /// 請求合計情報
+        /// 請求データ明細リスト
         /// </summary>
-        private List<RequestTotalData> m_LstRequestTotalData = new List<RequestTotalData>();
+        private List<Dictionary<int, List<RequestDataDetail>>> m_lstRequestDataDetail = new List<Dictionary<int, List<RequestDataDetail>>>();
 
         /// <summary>
-        /// 請求明細情報
+        /// 入金データ明細用リスト
         /// </summary>
-        private Dictionary<int,Dictionary<int,RequestDataDetail>> m_DicRequestDataDetail = new Dictionary<int, Dictionary<int, RequestDataDetail>>();
-
+        private List<DepositDataDetail> m_lstDepDataDetail = new List<DepositDataDetail>();
+        private List<DateTime> m_lstDepositDate = new List<DateTime>();
+        private List<int> m_lstDepositState = new List<int>();
+ 
         /// <summary>
-        /// 入金明細情報
+        /// 請求工事の工事基本情報
         /// </summary>
-        private Dictionary<int,DepositDataDetail> m_DicDepositDataDetail = new Dictionary<int, DepositDataDetail>();
+        private ConstructionBaseInfo m_BaseConstructionBaseInfo = new ConstructionBaseInfo();
 
         /// <summary>
-        /// 工事増減情報リスト
+        /// 請求工事の工事基本情報明細文字列リスト
         /// </summary>
-        private List<int> m_LstConstructionLink = new List<int>();
+        private Dictionary<int, string> m_dicBaseConstructionString = new Dictionary<int, string>();
 
         /// <summary>
-        /// 増減工事・基本情報
+        /// 工事基本情報リスト
         /// </summary>
-        private List<ConstructionBaseInfo> m_LstChldContructionData = new List<ConstructionBaseInfo>();
+        private Dictionary<int, ConstructionBaseInfo> m_dicConstructionBaseInfo = new Dictionary<int, ConstructionBaseInfo>();
 
         /// <summary>
-        /// 増減工事・明細情報
+        /// 工事基本情報明細文字列リスト
         /// </summary>
-        private Dictionary<int,Dictionary<int,string>> m_DicChldConstructionDetail = new Dictionary<int,Dictionary<int, string>>();
+        private Dictionary<int, string> m_dicConstructionName = new Dictionary<int, string>();
 
         /// <summary>
-        /// 増減工事・詳細台帳データ
+        /// 承認経路マスタ
         /// </summary>
-        private Dictionary<int,ConstructionLedger> m_DicChldConstructionLedger = new Dictionary<int, ConstructionLedger>();
+        private Dictionary<int, ApprovalMaster> m_dicApprovalMaster = new Dictionary<int, ApprovalMaster>();
 
         /// <summary>
         /// 承認データ
         /// </summary>
-        private Dictionary<int,List<ProcessApproval>> m_DicProcessApproval = new Dictionary<int, List<ProcessApproval>>();
+        private Dictionary<int, List<ProcessApproval>> m_dicProcessApproval = new Dictionary<int, List<ProcessApproval>>();
 
         /// <summary>
-        /// 承認経路データ
+        /// 工事詳細台帳
         /// </summary>
-        private Dictionary<int,ApprovalMaster> m_DicApprovalMaster = new Dictionary<int, ApprovalMaster>();
+        private ConstructionLedger m_ConstructionLedger = new ConstructionLedger();
 
         /// <summary>
-        /// 請求合計レコード更新追加確認ディクショナリ
+        /// 承認状態リスト
         /// </summary>
-        private Dictionary<RequestTotalData, bool> m_DicReqTotalRec = new Dictionary<RequestTotalData, bool>();
+        private List<int> m_lstOrderState = new List<int>();
 
+
+        private int m_nLeaderConstructionCode = 0;              // 詳細台帳用工事番号
+        private int m_nRequestNo = 0;                           // 請求No
+        private int m_nMaxOrderNo = 0;                          // 最大受付番号
+        private int m_nMaxRowNo = 0;                            // 最大行数
+
+        private int m_nOldRequestMonth = 0;                     // 起動時請求年月
+        private int m_nOldRequestAmount = 0;                    // 起動時請求金額
+
+
+        public RequestData m_RequestData = new RequestData();
+
+        #endregion
+
+        #region データグリッドビュ関連メソッド
+
+        #region DataGridViewの初期表示設定
         /// <summary>
-        /// 請求明細レコード更新追加確認ディクショナリ
+        /// DataGridViewの初期表示設定
         /// </summary>
-        private Dictionary<RequestDataDetail, bool> m_DicReqDetailRec = new Dictionary<RequestDataDetail, bool>();
+        private void SetGridDisplay()
+        {
+            try
+            {
+                // DataGrid全体のプロパティ設定
+                dgv1.EnableHeadersVisualStyles = false;
+                dgv1.AutoGenerateColumns = false;
+                dgv1.ColumnHeadersHeight = dgv1.ColumnHeadersHeight + 5;
+                dgv1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                dgv1.ColumnHeadersDefaultCellStyle.BackColor = Color.Aquamarine;
+                dgv1.AllowUserToAddRows = false;
+                dgv1.RowTemplate.Height = 22;
+                dgv1.Font = new System.Drawing.Font("ＭＳ 明朝", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
 
+
+                for (int i = 9; i < dgv1.ColumnCount - 2; i++)
+                {
+                    dgv1.Columns[i].Visible = false;
+                }
+
+                // 列タイトル設定
+                string[] title = new string[] { "", "", "", "", " 工事名", " 工事金額", "", " 合計", " 1回目", " 2回目", " 3回目", " 4回目", " 5回目", " 6回目", " 7回目", " 8回目", " 9回目", " 10回目", " 11回目", " 12回目", " 13回目", " 14回目", " 15回目", " 残り", " コメント" };
+
+                for (int i = 0; i < dgv1.ColumnCount; i++)
+                {
+                    dgv1.Columns[i].HeaderText = title[i];
+                }
+
+                // ヘッダ部構築
+                int cnt = Createheader(dgv1);
+
+                // ボディ部構築
+                cnt = CreateBody(dgv1, cnt);
+
+                // フッタ部構築
+                cnt = CreateFooter(dgv1, cnt);
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region  ヘッダ部の構築
         /// <summary>
-        /// 案件進捗日付データ
+        /// ヘッダ部の構築
         /// </summary>
-        private Dictionary<int, ConstructionProgressDate> m_DicConstProgressDate = new Dictionary<int, ConstructionProgressDate>();
+        private int Createheader(DataGridView dgv)
+        {
+            string[] title = new string[]{ "請求月", "承認状態", "請求合計", "請求金額", "消費税", "未入金分" };
+
+            dgv.Rows.Add(6);
+
+            for (int i = 0; i < 6; i++)
+            {
+                dgv.Rows[i].DefaultCellStyle.BackColor = Color.Yellow;
+                dgv.Rows[i].Frozen = true;
+
+                dgv[0, i].Value = i.ToString();
+                dgv[1, i].Value = ((int)dgvKind.Header).ToString();
+                dgv[6, i].Value = title[i];
+            }
+
+            dgv[3, 0].Value = "請求工事";
+
+            dgv.ClearSelection();
+
+            return 6;
+        }
         #endregion
 
+        #region ボディ部の構築
         /// <summary>
-        /// 請求データ未登録フラグ
+        /// ボディ部の構築
         /// </summary>
-        private bool isEmptyConstructionBaseInfo = false;
+        private int CreateBody(DataGridView dgv, int cnt)
+        {
+            dgv.Rows.Add(24);
 
+            for (int i = 0; i < 12; i++)
+            {
+                for (int j = 0; j < 2; j++)
+                {
+                    if (i % 2 != 0)
+                    {
+                        dgv.Rows[cnt].DefaultCellStyle.BackColor = Color.LightBlue;
+                    }
+                    dgv[0, cnt].Value = cnt.ToString();
+
+                    dgv[6, cnt].Style.ForeColor = Color.DarkGray;
+                    if (j == 0)
+                    {
+                        dgv[6, cnt].Value = "請求金額";
+
+                    }
+                    else
+                    {
+                        dgv[6, cnt].Value = "消費税";
+                    }
+
+                    if (cnt > 13)
+                    {
+                        dgv.Rows[cnt].Visible = false;
+                    }
+
+                    cnt++;
+                }
+            }
+
+            return cnt;
+        }
+        #endregion
+
+        #region フッタ部の構築
         /// <summary>
-        /// 請求書申請チェックと確認メッセージボックスの表示
+        /// フッタ部の構築
         /// </summary>
-        /// <param name="orderNo"></param>
-        /// <returns></returns>
-        private bool checkApproval(int orderNo)
+        private int CreateFooter(DataGridView dgv, int cnt)
         {
-            bool chkResult = true;
+            dgv.Rows.Add(4);
 
-            // 合計セクションの請求金額行を取得
-            var totalRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
+            string[] title = { "入金日", "入金金額", "差額", "入金確認" };
 
-            // 工事金額と請求金額を取得
-            double constPrice = (double)totalRow.Cells[GetColumnIndexNum(ColumnIndex.ConstructionPrice)].Value;
-            double billPrice = (double)totalRow.Cells[GetColumnIndexNum(ColumnIndex.Total)].Value;
+            for (int i = 0; i < 4; i++)
+            {
+                dgv.Rows[cnt].DefaultCellStyle.BackColor = Color.Yellow;
 
-            // 一括請求の場合
-            if ((m_ConstructionData.BillingSplitFlg == 0) && (orderNo == 1))
+                dgv[0, cnt].Value = cnt.ToString();
+                dgv[1, cnt].Value = ((int)dgvKind.Footer).ToString();
+                dgv[6, cnt].Value = title[i];
+
+                cnt++;
+            }
+
+            return cnt;
+        }
+        #endregion
+
+        #region 全ての回の合計を反映
+        /// <summary>
+        /// 全ての回の合計を反映
+        /// </summary>
+        private void setAllOrderTotal()
+        {
+            for (int i = 1; i <= m_nMaxOrderNo; i++)
             {
-                if (m_ConstructionData.ConstructionStatusFlg < 8)
+                setOrderTotal(i);
+            }
+
+            return;
+        }
+        #endregion
+
+        #region 指定回の合計を反映
+        /// <summary>
+        /// 指定回の合計を反映
+        /// </summary>
+        private void setOrderTotal(int nOrderNo)
+        {
+            int i;
+            int tcol = nOrderNo + 7;
+            int nPrice = 0;
+            int nTax = 0;
+            int val;
+
+            for (i = 6; i <= m_nMaxRowNo; i += 2)
+            {
+                if (dgv1[2, i].Value == null)
                 {
-                    // 工事のステータスが施工完了未満の場合はエラー
-                    MessageBox.Show(this, s_MessageNotCompletionConstruction, s_RequestApprovalDialogTitle, MessageBoxButtons.OK, MessageBoxIcon.Error);
-                    chkResult = false;
+                    break;
                 }
-                else if (constPrice > billPrice)
+
+                // 請求金額
+                if (dgv1[tcol, i].Value != null)
                 {
-                    // 請求金額合計が工事金額に満たないので、確認ダイアログを表示
-                    DialogResult res = MessageBox.Show(this, s_MessageNotCompletionRequest, s_RequestApprovalDialogTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
-                    chkResult = (res == DialogResult.Yes);
+                    val = CommonMotions.cnvInt(dgv1[tcol, i].Value.ToString());
+                    nPrice += val;
                 }
+
+                // 消費税
+                if (dgv1[tcol, i + 1].Value != null)
+                {
+                    val = CommonMotions.cnvInt(dgv1[tcol, i + 1].Value.ToString());
+                    nTax += val;
+                }
             }
-            else if (constPrice < billPrice)
+
+            setAmount(tcol, 2, nPrice + nTax);
+            setAmount(tcol, 3, nPrice);
+            setAmount(tcol, 4, nTax);
+
+            return;
+        }
+        #endregion
+
+        #region 残りの設定
+        /// <summary>
+        /// 残りの設定
+        /// </summary>
+        private void setBalance()
+        {
+            int i;
+
+            // 請求合計、請求金額、消費税、未入金分の残りを設定
+            for (i = 2; i < 6; i++)
             {
-                // 請求金額合計が工事金額を超えているので、確認ダイアログを表示
-                DialogResult res = MessageBox.Show(this, s_MessageOverRequest, s_RequestApprovalDialogTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
-                chkResult = (res == DialogResult.Yes);
+                calcBalance(i);
             }
-            else
+
+            // 工事一覧の残りを設定
+            for (i = 6; i < 29; i += 2)
             {
-                // 承認データチェック
-                RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
-                if (m_DicProcessApproval.ContainsKey(orderNo))
+                if (dgv1[2, i].Value == null)
                 {
-                    stat = CheckApprovalStatus(m_DicProcessApproval[orderNo], m_DicApprovalMaster);
+                    break;
                 }
 
-                if (stat == RequestApprovalStatus.NowInput)
+                calcBalance(i);
+
+                calcBalance(i + 1);
+            }
+        }
+        #endregion
+
+        #region 残りの算出
+        /// <summary>
+        /// 残りの算出
+        /// </summary>
+        private void calcBalance(int trow)
+        {
+            int nPrice = 0;
+            int nPayment = 0;
+            int tcol = dgv1.Columns.Count - 2;
+
+            nPrice = CommonMotions.cnvInt(dgv1[5, trow].Value);
+            nPayment = CommonMotions.cnvInt(dgv1[7, trow].Value);
+
+            setAmount(tcol, trow, nPrice - nPayment);
+        }
+        #endregion
+
+        #region 合計の設定
+        /// <summary>
+        /// 合計の設定
+        /// </summary>
+        private void setTotal()
+        {
+            int i;
+
+            // 請求合計、請求金額、消費税、未入金分の合計を設定
+            for (i = 2; i < 6; i++)
+            {
+                calcTotal(i);
+            }
+
+            // 工事一覧の合計を設定
+            for (i = 6; i < 29; i += 2)
+            {
+                if (dgv1[2, i].Value == null)
                 {
-                    DialogResult res = MessageBox.Show(this, s_MessageComfirmRequest, s_RequestApprovalDialogTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Question);
-                    chkResult = (res == DialogResult.Yes);
+                    break;
                 }
 
+                calcTotal(i);
+                calcTotal(i + 1);
+
             }
+        }
+        #endregion
 
-            return chkResult;
+        #region 合計の算出
+        /// <summary>
+        /// 合計の算出
+        /// </summary>
+        private void calcTotal(int trow)
+        {
+            int tcol = 7;
+            int nPrice = 0;
+
+            nPrice = GetTotalPrice(trow);
+            setAmount(tcol, trow, nPrice);
         }
+        #endregion
 
+        #region 合計金額の取得
         /// <summary>
-        /// DataGridViewでのカラムインデックス番号を取得
+        /// 合計金額の取得
         /// </summary>
-        /// <param name="cEnum">カラム種別</param>
-        /// <param name="count">請求情報の回数。請求情報以外のカラム種別を指定する際は省略可</param>
-        /// <returns></returns>
-        private int GetColumnIndexNum(ColumnIndex cEnum, int count = 1)
+        private int GetTotalPrice(int trow)
         {
-            int cIndex = -1;
-            try
+            int val = 0;
+            int total = 0;
+
+            for (int i = 8; i < dgv1.Columns.Count - 2; i++)
             {
-                if (cEnum < ColumnIndex.RequestInfo)
+                if (dgv1[i, trow].Value != null)
                 {
-                    cIndex = (int)cEnum;
+                    val = CommonMotions.cnvInt(dgv1[i, trow].Value.ToString());
                 }
-                else if (cEnum == ColumnIndex.RequestInfo)
-                {
-                    cIndex = (int)ColumnIndex.RequestInfo + count - 1;
-                }
                 else
                 {
-                    cIndex = (int)cEnum + m_RequestColumnCount - 1;
+                    val = 0;
                 }
+                total += val;
             }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-            }
 
-            return cIndex;
+            return total;
         }
+        #endregion
 
+        #region 金額の設定
         /// <summary>
-        /// DataGridViewでの行インデックス番号を取得
+        /// 金額の設定
         /// </summary>
-        /// <param name="cEnum">カラム種別</param>
-        /// <param name="count">請求情報の回数。請求情報以外のカラム種別を指定する際は省略可</param>
-        /// <returns></returns>
-        private int GetRowIndexNum(RowSectionIndex section, RowKind kind, int childIndex = 0)
+        private void setAmount(int tcol, int trow, int amount)
         {
-            int rIndex = -1;
-            try
+            dgv1[tcol, trow].Value = amount.ToString("#,0");
+
+            if (amount >= 0)
             {
-                var row = GetDataGridViewRowObject(section, kind, childIndex);
-                rIndex = (row != null) ? row.Index : -1;
+                dgv1[tcol, trow].Style.ForeColor = Color.Black;
             }
-            catch (Exception ex)
+            else
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                dgv1[tcol, trow].Style.ForeColor = Color.Red;
             }
-
-            return rIndex;
         }
+        #endregion
 
+        #region セル編集終了
         /// <summary>
-        /// DataGridViewRowオブジェクトをハッシュテーブルより取得する
+        ///  セル編集終了
         /// </summary>
-        /// <param name="sectIndex"></param>
-        /// <param name="kind"></param>
-        /// <param name="childIndex"></param>
-        /// <returns></returns>
-        private DataGridViewRow GetDataGridViewRowObject(RowSectionIndex sectIndex, RowKind kind, int childIndex = 0)
+        private void CellEditEnd(int tcol, int trow)
         {
-            DataGridViewRow dataGridRow = null;
+            // まだ編集中
+            if (dgv1[tcol, trow].IsInEditMode == true)
+            {
+                return;
+            }
 
-            try
+            if (dgv1[tcol, trow].Value == null)
             {
-                if (m_HtRowObject.ContainsKey(sectIndex))
+                dgv1[tcol, trow].Value = string.Empty;
+
+                return;
+            }
+
+
+            string str = dgv1[tcol, trow].Value.ToString().Replace(",", string.Empty);
+            if (string.IsNullOrEmpty(str) != true)
+            {
+                try
                 {
-                    var lst = m_HtRowObject[sectIndex] as List<Hashtable>;
+                    int n = int.Parse(str);
 
-                    if (childIndex < lst.Count)
+                    if (n >= 0)
                     {
-                        var htInSection = lst[childIndex] as Hashtable;
+                        dgv1[tcol, trow].Style.ForeColor = Color.Black;
+                    }
+                    else
+                    {
+                        dgv1[tcol, trow].Style.ForeColor = Color.Red;
+                    }
 
-                        if (htInSection.ContainsKey(kind))
-                        {
-                            dataGridRow = (DataGridViewRow)htInSection[kind];
-                        }
-                    }
+                    string s = n.ToString("#,0");
+                    dgv1[tcol, trow].Value = s;
+
                 }
+                catch
+                {
+                    dgv1[tcol, trow].Value = null;
+                    return;
+                }
             }
-            catch (Exception ex)
+            else
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                dgv1[tcol, trow].Value = null;
+
+                return;
             }
 
-            return dataGridRow;
+            return;
         }
+        #endregion
 
+        #endregion
+
+        #region チェック関連メソッド
+
+        #region 初期起動時チェック
         /// <summary>
-        /// DataGridViewRowオブジェクトをハッシュテーブルに設定する
+        /// 初期起動時チェック
         /// </summary>
-        /// <param name="gridRow"></param>
-        /// <param name="sectIndex"></param>
-        /// <param name="kind"></param>
-        /// <param name="childIndex"></param>
-        private void SetDataGridViewRowObject(DataGridViewRow gridRow, RowSectionIndex sectIndex, RowKind kind, int childIndex = 0)
+        private int CheckInit()
         {
-            try
-            {
-                List<Hashtable> lst;
-                if (!m_HtRowObject.ContainsKey(sectIndex))
-                {
-                    // ハッシュテーブルのリストを追加
-                    lst = new List<Hashtable>();
-                    m_HtRowObject.Add(sectIndex, lst);
+            int ret;
+            string wrk ;
+
+            StringBuilder sql = new StringBuilder();
+            IOConstructionLink ioLink = new IOConstructionLink();
+            IORequestData ioData = new IORequestData();
+
+            List<ConstructionLink> lstLink = new List<ConstructionLink>();
+            ArrayList ar = new ArrayList();
+
+            ret = -1;
+
+            try{
+                wrk = string.Format(" Where FluctuationCode = {0}", m_ConstructionCode);
+
+                if(ioLink.SelectAction(wrk, ref lstLink ) == false){
+                    return -1;
                 }
-                else
-                {
-                    lst = m_HtRowObject[sectIndex] as List<Hashtable>;
-                }
 
-                Hashtable htInSection;
-                if (lst.Count <= childIndex)
+                // 独立系はOK
+                if( lstLink.Count == 0)
                 {
-                    htInSection = new Hashtable();
-                    lst.Add(htInSection);
+                    return 0 ;
                 }
-                else
-                {
-                    htInSection = lst[childIndex] as Hashtable;
-                }
 
-                if (!htInSection.ContainsKey(kind))
+                // 結合子の場合は、結合親の本工事として請求データが存在するか確認する
+                sql.AppendLine("SELECT ");
+                sql.AppendLine("dt.MainConstructionCode ");
+                sql.AppendLine("FROM ");
+                sql.AppendLine("RequestHead hd ");
+                sql.AppendLine(",INNER JOIN RequestData dt ON hd.RequestNo = dt.RequestNo ");
+                sql.AppendLine("WHERE  ");
+                sql.AppendFormat("hd.ReqConstructionCode = {0}", lstLink[0].ConstructionCode);
+                sql.AppendFormat("And dt.MainConstructionCode = {0}", m_ConstructionCode);
+
+                if (ioData.ExecuteReader(sql.ToString(), ref ar) == false)
                 {
-                    htInSection.Add(kind, gridRow);
+                    return -1;
                 }
-                else
-                {
-                    htInSection[kind] = gridRow;
-                }
 
+                ret = ar.Count;
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                ioLink.close();
+                ioLink = null;
+                ioData.close();
+                ioData = null;
+            }
+
+            return ret;
         }
+        #endregion
 
-        /// <summary>
-        /// DataGridViewの初期表示設定
-        /// </summary>
-        private void SetGridDisplay()
+        #region 承認チェック
+
+        private int CheckApproval(ref List<int> lstMainConstructionCode)
         {
+            IOConstructionProgressDate ioProg = new IOConstructionProgressDate();
+
             try
             {
-                // DataGrid全体のプロパティ設定
-                dgv1.EnableHeadersVisualStyles = false;
-                dgv1.AutoGenerateColumns = false;
-                dgv1.ColumnHeadersHeight = this.dgv1.ColumnHeadersHeight + 5;
-                dgv1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
-                dgv1.ColumnHeadersDefaultCellStyle.BackColor = Color.Aquamarine;
-                dgv1.AllowUserToAddRows = false;
-                dgv1.RowTemplate.Height = 22;
-                dgv1.Font = new System.Drawing.Font("ＭＳ 明朝", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
+                int nBalance = 0;
 
-                // 列タイトル設定
-                foreach (ColumnIndex cIndex in s_HtColumnTitles.Keys)
+                // 一括請求の場合
+                if (m_BaseConstructionBaseInfo.BillingSplitFlg == 0)
                 {
-                    if (s_HtColumnTitles[cIndex].GetType() == typeof(string))
+                    Dictionary<int, RequestData> dicReqData = m_lstRequestData[m_nMaxOrderNo - 1];
+
+                    List<int> lstKey = new List<int>(dicReqData.Keys);
+
+                    foreach (int nMainConstructionCode in lstKey)
                     {
-                        dgv1.Columns[GetColumnIndexNum(cIndex)].HeaderText = (string)s_HtColumnTitles[cIndex];
-                    }
-                    else if (s_HtColumnTitles[cIndex].GetType() == typeof(List<string>))
-                    {
-                        var lst = s_HtColumnTitles[cIndex] as List<string>;
-                        foreach (var strTitle in lst)
+                        ConstructionBaseInfo Info = null;
+
+                        if (m_dicConstructionBaseInfo.TryGetValue(nMainConstructionCode, out Info) == true)
                         {
-                            int colIndex = GetColumnIndexNum(cIndex, lst.IndexOf(strTitle) + 1);
-                            dgv1.Columns[colIndex].HeaderText = strTitle;
-                            dgv1.Columns[colIndex].HeaderCell.Style.ForeColor = Color.DarkGray;
+                            if (Info.ConstructionStatusFlg == (int)CommonDefine.StatNumArray.Status9)
+                            {
+                                continue;
+                            }
                         }
+                        string sql = ioProg.CreatePrimarykeyString(nMainConstructionCode, (int)CommonDefine.StatNumArray.Status9);
+                        List<ConstructionProgressDate> lstProg = new List<ConstructionProgressDate>();
+                        if (ioProg.SelectAction(sql, ref lstProg) == false)
+                        {
+                            return (int)CheckResult.UnknownError;
+                        }
+
+                        // 施工完了が存在しない場合
+                        if (lstProg.Count == 0)
+                        {
+                            lstMainConstructionCode.Add(nMainConstructionCode);
+                        }
                     }
+                    // 本工事番号が登録されている場合
+                    if (lstMainConstructionCode.Count > 0)
+                    {
+                        return (int)CheckResult.ErrorStatus;
+                    }
+
+                    nBalance = CommonMotions.cnvInt(dgv1[dgv1.ColumnCount-1, 2].Value); 
+                    // 請求残が存在する場合
+                    if( nBalance > 0 )
+                    {
+                        return (int)CheckResult.WarningUnmatch;
+                    }
                 }
 
-                // 行追加処理
-                int rIndex = 0;
-                foreach (RowSectionIndex sectionIndex in Enum.GetValues(typeof(RowSectionIndex)))
+                nBalance = CommonMotions.cnvInt(dgv1[dgv1.ColumnCount - 1, 2].Value);
+                // 請求残がマイナスの場合
+                if( nBalance < 0 )
                 {
-                    // セクションごとの処理
+                    return (int)CheckResult.WarningOver;
+                }
 
-                    for (int sectLoop = 0; sectLoop < ((sectionIndex == RowSectionIndex.ChildConstruction) ? 4 : 1); sectLoop++)
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioProg.close();
+                ioProg = null;
+            }
+
+
+            return (int)CheckResult.NoError;
+        }
+        #endregion
+
+        #region エラー表示セット
+        private void SetErrorIndicate( List<int>lstErrorConstructionCode)
+        {
+            foreach( int nMainConstrucitionCode in lstErrorConstructionCode)
+            {
+                for (int i = 6; i <= m_nMaxRowNo; i += 2)
+                {
+                    int nConstructionCode = int.Parse(dgv1[2, i].Value.ToString());
+                    if (nConstructionCode == nMainConstrucitionCode)
                     {
-                        // 増減工事セクションは4回繰り返す
+                        dgv1[4, i].Style.BackColor = Color.Red;
 
-                        foreach (RowKind kindIndex in s_HtRowSections[sectionIndex])
-                        {
-                            // セクション内の行の追加
-                            dgv1.Rows.Add();
-                            dgv1.Rows[dgv1.RowCount - 1].Cells[GetColumnIndexNum(ColumnIndex.SectionIndex)].Value = sectionIndex;
-                            dgv1.Rows[dgv1.RowCount - 1].Cells[GetColumnIndexNum(ColumnIndex.RowKind)].Value = kindIndex;
+                        break;
+                    }
+                }
+            }
 
-                            // ハッシュデータに行オブジェクトを追加
-                            SetDataGridViewRowObject(dgv1.Rows[rIndex], sectionIndex, kindIndex, sectLoop);
+            return ;
+        }
+        #endregion
 
-                            // 固定表示ラベルの設定
-                            if (s_HtLabels.ContainsKey(sectionIndex) && s_HtLabels[sectionIndex].ContainsKey(kindIndex))
-                            {
-                                foreach (ColumnIndex cIndex in s_HtLabels[sectionIndex][kindIndex].Keys)
-                                {
-                                    int cNum = GetColumnIndexNum(cIndex);
-                                    dgv1.Rows[rIndex].Cells[cNum].Value = s_HtLabels[sectionIndex][kindIndex][cIndex];
-                                    dgv1.Rows[rIndex].Cells[cNum].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
-                                }
-                            }
+        #region エラー表示クリア
+        private void ClearErrorIndicate()
+        {
+            int nColor = 0;
 
-                            // 背景色の設定
-                            SetRowBackgroundColor(sectionIndex, dgv1.Rows[rIndex], sectLoop);
+            for (int i = 6; i <= m_nMaxRowNo; i += 2)
+            {
+                if ( nColor == 0)
+                {
+                    dgv1[4, i].Style.BackColor = Color.White;
 
-                            if (sectionIndex == RowSectionIndex.ChildConstruction)
-                            {
-                                // 増減工事行は一旦文字色をDarkGrayに設定
-                                dgv1.Rows[rIndex].DefaultCellStyle.ForeColor = Color.DarkGray;
+                    nColor = 1;
+                }
+                else
+                {
+                    dgv1[4, i].Style.BackColor = Color.LightBlue;
 
-                            }
-                            rIndex++;
-                        }
-                    }
+                    nColor = 0;
                 }
+            }
 
-                dgv1.Rows[2].Frozen = true;
+            return;
+        }
+        #endregion
 
-                GetDisplayDatas();
+        #endregion
+
+        #region データ取得関連メソッド
+
+        #region 表示データの取得
+        private void GetRequestDispData()
+        {
+            // 請求ヘッダの取得
+            GetRequestHead();
+
+            // 請求ヘッダが存在しない場合(初回起動）
+            if (m_lstRequestHead.Count == 0)
+            {
+                // 請求データを現在の工事データより構築する
+                CreateRequest();
             }
-            catch (Exception ex)
+            else
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                RequestHead    ReqHead = m_lstRequestHead[m_nMaxOrderNo-1];
+
+                // 請求年月と請求金額合計を退避（詳細台帳反映用）
+                m_nOldRequestMonth = ReqHead.RequestMonth;
+                m_nOldRequestAmount = ReqHead.RequestAmount;
+
+                // 請求データと請求明細の取得
+                GetRequestDataAndDetail(ReqHead.RequestNo);
+
             }
+
+            // 入金データの取得
+            GetDepositData();
+
+            // 対象が結合子工事の場合
+            if (m_BaseConstructionBaseInfo.JoinFlg == 2)
+            {
+                GetConstructionLinkFromFluctuationCode(m_BaseConstructionBaseInfo.ConstructionCode, 1, ref m_nLeaderConstructionCode);
+            }
+            else
+            {
+                m_nLeaderConstructionCode = m_ConstructionCode;
+            }
+
+            // 詳細台帳の取得
+            GetConstructionLedger(m_nLeaderConstructionCode, ref m_ConstructionLedger);
+
+            // 承認経路の取得
+            GetApprovalMaster(m_BaseConstructionBaseInfo.ConstructionPersonCode, ref m_dicApprovalMaster);
+
+            // 承認データの取得
+            GetProcessApproval( m_ConstructionCode, ref m_dicProcessApproval );
+
         }
+        #endregion
 
-        /// <summary>
-        /// 増減工事行の追加処理
-        /// </summary>
-        /// <param name="stbIndex"></param>
-        private void AddChildConstructionInfoRow(int stbIndex)
+        #region 工事文字列の追加
+        private void AddConstructionString(int key, string str)
         {
+            string wk;
+
+            if (m_dicConstructionName.TryGetValue(key, out wk) == false)
+            {
+                m_dicConstructionName.Add(key, str);
+            }
+
+            return;
+        }
+        #endregion
+
+        #region 工事基本情報の追加
+        private void AddConstructionBaseInfo(int key, ConstructionBaseInfo info)
+        {
+            ConstructionBaseInfo wk;
+
+            if (m_dicConstructionBaseInfo.TryGetValue(key, out wk) == false)
+            {
+                m_dicConstructionBaseInfo.Add(key, info);
+            }
+
+            return;
+        }
+        #endregion
+
+        #region 請求ヘッダの取得
+        private void GetRequestHead()
+        {
+            IORequestHead ioReqHead = new IORequestHead();
+            IORequestData ioReqData = new IORequestData();
+            IORequestDataDetail ioReqDetail = new IORequestDataDetail();
+
+            string strSQL;
+
             try
             {
-                // 増減工事最終行のオブジェクトを取得
-                var lastChldConstRow = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, m_ChildConstructionRowCount - 1);
+                // 工事基本情報の取得
+                GetConstructionBaseInfo(m_ConstructionCode, ref m_BaseConstructionBaseInfo);
 
-                // 増減工事最終行の行番号を取得
-                int lastChldConstRowIndex = dgv1.Rows.IndexOf(lastChldConstRow);
+                AddConstructionBaseInfo(m_ConstructionCode, m_BaseConstructionBaseInfo);
 
-                // 行を追加
-                foreach (RowKind kindIndex in s_HtRowSections[RowSectionIndex.ChildConstruction])
+                // 工事基本情報明細（文字列）の取得
+                GetConstructionBaseInfoDetail(m_ConstructionCode, ref m_dicBaseConstructionString);
+
+
+                // 請求ヘッダを取得
+                strSQL = ioReqHead.CreateSubkeyString(m_ConstructionCode);
+                strSQL += " Order by OrderNo Asc " ;
+                if (ioReqHead.SelectAction(strSQL, ref m_lstRequestHead) == false)
                 {
-                    // 行オブジェクト作成
-                    var rowObject = new DataGridViewRow();
+                    return;
+                }
 
-                    // セクション内の行の挿入
-                    dgv1.Rows.Insert(++lastChldConstRowIndex, rowObject);
+                // 請求ヘッダがない場合は請求データがＤＢ上に存在しないため終了
+                if (m_lstRequestHead.Count == 0)
+                {
+                    return;
+                }
 
-                    dgv1.Rows[lastChldConstRowIndex].Cells[GetColumnIndexNum(ColumnIndex.SectionIndex)].Value = RowSectionIndex.ChildConstruction;
-                    dgv1.Rows[lastChldConstRowIndex].Cells[GetColumnIndexNum(ColumnIndex.RowKind)].Value = kindIndex;
+                // 最新の請求Noおよび受付番号を確保
+                m_nRequestNo = m_lstRequestHead[m_lstRequestHead.Count-1].RequestNo;
+                m_nMaxOrderNo = m_lstRequestHead[m_lstRequestHead.Count-1].OrderNo;
 
-                    // 行の背景色を設定
-                    SetRowBackgroundColor(RowSectionIndex.ChildConstruction, dgv1.Rows[lastChldConstRowIndex], stbIndex);
+                // 請求ヘッダレコード分ループ
+                foreach (RequestHead ReqHead in m_lstRequestHead)
+                {
+                    // 直近受付は、工事情報と絡めて実施
+                    if (ReqHead.OrderNo == m_nMaxOrderNo)
+                    {
+                        break;
+                    }
 
-                    // ハッシュデータに行オブジェクトを追加
-                    SetDataGridViewRowObject(dgv1.Rows[lastChldConstRowIndex], RowSectionIndex.ChildConstruction, kindIndex, stbIndex);
+                    // 請求データリストの構築（ＤＢ取得用）
+                    List<RequestData> lstData = new List<RequestData>();
 
-                    // 固定ラベルの表示
-                    if (s_HtLabels.ContainsKey(RowSectionIndex.ChildConstruction))
+                    // 請求データの取得(検索キーは請求Noのみ)
+                    strSQL = ioReqData.CreatePrimarykeyString(ReqHead.RequestNo);
+                    strSQL += " Order by MainConstructionCode Asc ";
+                    if (ioReqData.SelectAction(strSQL, ref lstData) == false)
                     {
-                        if (s_HtLabels[RowSectionIndex.ChildConstruction].ContainsKey(kindIndex))
+                        return;
+                    }
+
+                    if( lstData.Count == 0){
+                        return;
+                    }
+
+                    // 請求データ辞書（キー：本工事番号）の構築
+                    Dictionary<int, RequestData> dicData = new Dictionary<int, RequestData>();
+
+                    // 請求データ明細リスト辞書（キー：本工事番号）の構築
+                    Dictionary<int, List<RequestDataDetail>> dicDetail = new Dictionary<int, List<RequestDataDetail>>(); 
+
+                    foreach( RequestData ReqData in lstData)
+                    {
+                        dicData.Add(ReqData.MainConstructionCode, ReqData);
+                        
+                        List<RequestDataDetail> lstDetail = new List<RequestDataDetail>();
+
+                        // 請求データ明細の取得
+                        strSQL = ioReqDetail.CreatePrimarykeyString(ReqData.RequestNo, ReqData.MainConstructionCode);
+                        strSQL += " Order by ConstructionKind Asc, ConstructionCode Asc ";
+                        if (ioReqDetail.SelectAction(strSQL, ref lstDetail) == false)
                         {
-                            foreach (var colIndex in s_HtLabels[RowSectionIndex.ChildConstruction][kindIndex].Keys)
-                            {
-                                int cIndex = GetColumnIndexNum(colIndex);
-                                dgv1.Rows[lastChldConstRowIndex].Cells[cIndex].Value = s_HtLabels[RowSectionIndex.ChildConstruction][kindIndex][colIndex];
-                            }
+                            return;
                         }
+
+                        if( lstDetail.Count == 0){
+                            return;
+                        }
+
+                        dicDetail.Add(ReqData.MainConstructionCode, lstDetail); 
+                        
                     }
 
+                    m_lstRequestData.Add(dicData);
+                    m_lstRequestDataDetail.Add(dicDetail);
                 }
 
-                m_ChildConstructionRowCount++;
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                ioReqHead.close();
+                ioReqHead = null;
+                ioReqData.close();
+                ioReqData = null;
+                ioReqDetail.close();
+                ioReqDetail = null;
+            }
+
         }
+        #endregion
 
-        /// <summary>
-        /// 行の背景色の設定
-        /// </summary>
-        /// <param name="sectionIndex"></param>
-        /// <param name="gridRow"></param>
-        /// <param name="sectLoop"></param>
-        private void SetRowBackgroundColor(RowSectionIndex sectionIndex, DataGridViewRow gridRow, int sectLoop = 0)
+        #region 請求データ、明細の取得
+        private void GetRequestDataAndDetail(int nRequestNo)
         {
+            string sql = "";
+            string str = "";
+
+            IORequestData ioReqData = new IORequestData();
+            IORequestDataDetail ioReqDetail = new IORequestDataDetail();
+
+            Dictionary<int, RequestData> dicData = new Dictionary<int, RequestData>();
+            Dictionary<int, List<RequestDataDetail>> dicDetail = new Dictionary<int, List<RequestDataDetail>>();
+
             try
             {
-                // 行の背景色の設定
-                if (s_HtRowColors.ContainsKey(sectionIndex))
+                List<int> lstMainConstructionCode = new List<int>();
+
+                // 結合フラグが結合（親）以外の場合
+                if (m_BaseConstructionBaseInfo.JoinFlg != 1)
                 {
-                    if (s_HtRowColors[sectionIndex].GetType() == typeof(Color))
+                    // 単独、結合（子）は、請求工事＝本工事
+                    lstMainConstructionCode.Add(m_ConstructionCode);
+
+                }
+                else
+                {
+                    // リンク種別が結合子の工事で検索
+                    GetConstructionLink(m_ConstructionCode, 1, ref lstMainConstructionCode);
+                }
+
+                List<RequestData> lstDataWork = new List<RequestData>();
+                sql = ioReqData.CreatePrimarykeyString(nRequestNo);
+                sql += " Order By MainConstructionCode Asc ";
+
+                if (ioReqData.SelectAction(sql, ref lstDataWork) == false)
+                {
+                    return;
+                }
+ 
+                Dictionary<int,RequestData> dicDataWork = new Dictionary<int,RequestData>();
+                foreach (RequestData ReqData in lstDataWork)
+                {
+                    dicDataWork.Add(ReqData.MainConstructionCode, ReqData);
+                }
+
+
+                ConstructionBaseInfo info = null;
+                Dictionary<int, string> dicString = null;
+
+                foreach (int nMainConstructonCode in lstMainConstructionCode)
+                {
+                    bool bNewMainConstruction = false;
+
+                    RequestData ReqData = null;
+
+                    info = new ConstructionBaseInfo();
+                    dicString = new Dictionary<int, string>();
+
+                    GetConstructionBaseInfo(nMainConstructonCode, ref info);
+                    AddConstructionBaseInfo(nMainConstructonCode, info);
+
+                    GetConstructionBaseInfoDetail(nMainConstructonCode, ref dicString);
+                    // 工事件名
+                    if (dicString.TryGetValue((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName, out str) == true)
                     {
-                        // セクションごとの色を設定
-                        gridRow.DefaultCellStyle.BackColor = (Color)s_HtRowColors[sectionIndex];
+                        AddConstructionString(nMainConstructonCode, str);
                     }
-                    else if (s_HtRowColors[sectionIndex].GetType() == typeof(List<Color>))
+
+                    // 請求データが存在しない場合（結合子工事が増えた）
+                    if (dicDataWork.TryGetValue(nMainConstructonCode, out ReqData) == false)
                     {
-                        var lst = s_HtRowColors[sectionIndex] as List<Color>;
-                        gridRow.DefaultCellStyle.BackColor = lst[(sectLoop % lst.Count)];
+                        // 請求データを生成
+                        ReqData = new RequestData();
+
+                        ReqData.RequestNo = nRequestNo;
+                        ReqData.MainConstructionCode = nMainConstructonCode;
+                        // 工事件名
+                        ReqData.ConstructionName = str;
+
+                        bNewMainConstruction = true;
                     }
-                    else
+
+                    dicData.Add(nMainConstructonCode, ReqData);
+
+                    List<RequestDataDetail> lstDetailWork = new List<RequestDataDetail>();
+                    List<RequestDataDetail> lstDetail = new List<RequestDataDetail>();
+                    Dictionary<int, RequestDataDetail> dicDetailWork = new Dictionary<int, RequestDataDetail>();
+
+                    List<int> lstConstructionCode = new List<int>();
+                    GetConstructionLink(nMainConstructonCode, 0, ref lstConstructionCode);
+
+                    if (bNewMainConstruction == false)
                     {
-                        gridRow.DefaultCellStyle.BackColor = Color.White;
+                        sql = ioReqDetail.CreatePrimarykeyString(nRequestNo, nMainConstructonCode);
+                        sql += " Order By ConstructionKind Asc, ConstructionCode Asc";
+                        if (ioReqDetail.SelectAction(sql, ref lstDetailWork) == false)
+                        {
+                            return;
+                        }
+                        foreach (RequestDataDetail ReqDetail in lstDetailWork)
+                        {
+                            dicDetailWork.Add(ReqDetail.ConstructionCode, ReqDetail);
+                        }
+
                     }
 
-                    if (gridRow.DefaultCellStyle.BackColor == Color.White)
+                    RequestDataDetail ReqDetailMain = null;
+
+                    // 本工事で構築
+                    if (dicDetailWork.TryGetValue(nMainConstructonCode, out ReqDetailMain) == false)
                     {
-                        gridRow.Cells[GetColumnIndexNum(ColumnIndex.Headline)].Style.BackColor = System.Drawing.SystemColors.Control;
-                        gridRow.Cells[GetColumnIndexNum(ColumnIndex.Label)].Style.BackColor = System.Drawing.SystemColors.Control;
+                        ReqDetailMain = new RequestDataDetail();
+                        ReqDetailMain.RequestNo = nRequestNo;
+                        ReqDetailMain.MainConstructionCode = nMainConstructonCode;
+                        ReqDetailMain.ConstructionKind = 0;
                     }
+                    lstDetail.Add(ReqDetailMain);
+ 
+                    foreach (int nConstructionCode in lstConstructionCode)
+                    {
+                        RequestDataDetail ReqDetailSub = null;
+
+                        if (dicDetailWork.TryGetValue(nConstructionCode, out ReqDetailSub) == false)
+                        {
+                            ReqDetailSub = new RequestDataDetail();
+                            ReqDetailSub.RequestNo = nRequestNo;
+                            ReqDetailSub.MainConstructionCode = nMainConstructonCode;
+                            ReqDetailSub.ConstructionKind = 1;
+                        }
+
+                        info = new ConstructionBaseInfo();
+                        GetConstructionBaseInfo(nConstructionCode, ref info);
+                        AddConstructionBaseInfo(nConstructionCode, info);
+
+                        dicString = new Dictionary<int, string>();
+                        GetConstructionBaseInfoDetail(nConstructionCode, ref dicString);
+
+                        if( dicString.TryGetValue((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName, out str) == true ){
+                            AddConstructionString(nConstructionCode, str);
+                        }
+
+                        lstDetail.Add(ReqDetailSub); 
+                    }
+
+                    dicDetail.Add( nMainConstructonCode, lstDetail);
+
                 }
 
+                m_lstRequestData.Add(dicData);
+                m_lstRequestDataDetail.Add(dicDetail);
+
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                ioReqData.close();
+                ioReqData = null;
+                ioReqDetail.close();
+                ioReqDetail = null;
+            }
+
+
         }
+        #endregion
 
-        /// <summary>
-        /// データベースよりデータを取得し、画面表示に反映する
-        /// </summary>
-        private void GetDisplayDatas()
+        #region 入金データ取得
+        private void GetDepositData()
         {
-            try
+            for (int i = 0; i < m_lstRequestHead.Count; i++)
             {
-                // 工事基本情報取得
-                if (GetConstructionBaseInfo(m_ConstructionCode, ref m_ConstructionData))
-                {
-                    // 請求データ取得
-                    if (GetRequestData(ref m_RequestData))
-                    {
-                        // 請求合計データ取得
-                        if (GetRequestTotalDatas(m_RequestData.RequestNo, ref m_LstRequestTotalData))
-                        {
-                            // 請求明細データ取得
-                            GetRequestDataDetails(m_RequestData.RequestNo, ref m_DicRequestDataDetail);
+                RequestHead ReqHead = m_lstRequestHead[i];
 
-                            // 入金明細データ取得
-                            GetDepositDataDetail(m_RequestData.RequestNo, ref m_DicDepositDataDetail);
+                List<DepositDataDetail> lstDepDetail = new List<DepositDataDetail>() ;
 
-                            // 承認データ取得
-                            GetProcessApproval(m_ConstructionCode, ref m_DicProcessApproval);
-                        }
-                    }
-                    else
+                GetDepositDataDetail( ReqHead.RequestNo, ref lstDepDetail);
+
+                DepositDataDetail DepDetail = null;
+                int nDepositState = (int)DepositState.None;
+                DateTime dtDeposit = DateTime.MinValue;
+
+                if (lstDepDetail.Count > 0)
+                {
+                    DepDetail = lstDepDetail[0];
+                    if (DepDetail.ApprovalEndFlg == true)
                     {
-                        isEmptyConstructionBaseInfo = true;
-                        // 工事番号から工事基本情報を取得
-                        m_RequestData.RequestNo = m_ConstructionCode;
-                        m_RequestData.ConstructionCode = m_ConstructionCode;
-                        if (!GetRequestDataFromConstructionBase(ref m_RequestData)) return;
+                        nDepositState = (int)DepositState.Done;
                     }
 
-                    // 工事基本情報明細取得
-                    GetConstructionBaseInfoDetail(m_ConstructionCode, ref m_DicConstructionDetail);
+                    DepositData DepData = new DepositData();
+                    GetDepositData(DepDetail.OrderersDivision, DepDetail.OrderersCode, DepDetail.TargetDate, DepDetail.SeqNo, ref DepData);
+                    dtDeposit = DepData.DepositDate;
 
-                    // 工事詳細台帳データ取得
-                    GetConstructionLedger(m_ConstructionCode, ref m_ConstructionLedger);
+                }
+                else
+                {
+                    DepDetail = new DepositDataDetail();
+                }
 
-                    // 工事増減情報取得
-                    if (GetConstructionLink(ref m_LstConstructionLink))
-                    {
-                        // 増減工事の工事基本情報をすべて取得
-                        if (GetChildConstructionBaseInfo(m_LstConstructionLink, ref m_LstChldContructionData))
-                        {
-                            // 増減工事の工事明細情報をすべて取得
-                            GetChildConstructionBaseInfoDetail(m_LstConstructionLink, ref m_DicChldConstructionDetail);
+                m_lstDepDataDetail.Add(DepDetail);
+                m_lstDepositState.Add(nDepositState);
+                m_lstDepositDate.Add(dtDeposit);
 
-                            // 増減工事の工事詳細台帳データを取得
-                            GetChildConstructionLedger(m_LstConstructionLink, ref m_DicChldConstructionLedger);
-                        }
-                    }
+            }
+        }
+        #endregion
 
-                    // 案件進捗日付データを取得
-                    GetConstructionProgressDate(m_ConstructionCode, ref m_DicConstProgressDate);
+        #region 請求データの生成
+        private void CreateRequest()
+        {
+            // 最大受付番号加算
+            m_nMaxOrderNo++;
 
-                    // 承認経路マスタを取得
-                    GetApprovalMaster(m_ConstructionData.ConstructionPersonCode, ref m_DicApprovalMaster);
+            // 請求ヘッダの生成
+            CreateRequestHead(m_nMaxOrderNo);
 
-                }
+            // 請求データの生成
+            CreateRequestData();
+            
+            // 請求データ明細の生成
+            CreateRequestDataDetail();
+        }
+        #endregion
 
-                // 請求先名ラベル設定
-                if (m_DicConstructionDetail.ContainsKey((int)ConstructionBaseInfoDetail.DetailDataNo.OrderersName))
-                {
-                    label1.Text = (string)m_DicConstructionDetail[(int)ConstructionBaseInfoDetail.DetailDataNo.OrderersName];
-                }
-                label1.TextAlign = ContentAlignment.MiddleLeft;
+        #region 請求ヘッダの生成
+        private void CreateRequestHead(int nOrderNo)
+        {
+            RequestHead ReqHead = new RequestHead();
 
-                // 工事状態表示
-                SetConstructionStatus();
+            ReqHead.ReqConstructionCode = m_ConstructionCode;           // 請求工事番号
 
-                // 本工事行表示
-                SetOriginalConstructionInfo();
+            string str;
 
-                // 増減工事行表示
-                SetChildConstructionInfo();
+            // 請求Noは登録時に採番（初期値）  
 
-                // 請求明細列表示
-                foreach (var total in m_LstRequestTotalData)
-                {
-                    SetRequestInfoColumn(total.OrderNo - 1);
-                }
+            // 受付番号は引数の受付番号に準拠                                      
+            ReqHead.OrderNo = nOrderNo;
 
-                // 入金情報行表示
-                SetDepositInfo();
+            // 請求年月も登録時に決定（初期値）      
 
-                // 自動計算セル表示
-                SetAutoCalcRow();
+            ReqHead.OrderersDivision = m_BaseConstructionBaseInfo.OrderersDivision;   // 発注者区分   
+            ReqHead.OrderersCode = m_BaseConstructionBaseInfo.OrderersCode;           // 発注者コード
 
-                // 合計行表示
-                SetTotalInfo();
+            // 発注者名
+            m_dicBaseConstructionString.TryGetValue((int)ConstructionBaseInfoDetail.DetailDataNo.OrderersName, out str);
+            ReqHead.OrderersName = str;
 
-                // 入金情報行表示
-                SetDepositInfo();
+            // 工事件名
+            m_dicBaseConstructionString.TryGetValue((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName, out str);
+            ReqHead.ReqConstructionName = str;
 
-                // データが存在しない場合
-                if (m_LstRequestTotalData.Count == 0)
-                {
-                    // 1回目を追加
-                    AddRequest();
-                }
+            // 請求金額関係は全て0（初期値）
+            // 備考は初期値
+            // 割当済フラグも初期値
+            // 請求書Noも初期値
 
+            // リストに追加
+            m_lstRequestHead.Add(ReqHead);
 
-            }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-            }
-
+            return;
         }
+        #endregion
 
-        /// <summary>
-        /// 工事状態表示設定
-        /// </summary>
-        private void SetConstructionStatus()
+        #region 請求データの生成
+        private void CreateRequestData()
         {
-            // 状態フラグが10(請求完了)が存在すれば
-            if (m_DicConstProgressDate.ContainsKey(10))
+            List<int> lstConstructionCode = new List<int>();
+            Dictionary<int, RequestData> dicData = new Dictionary<int, RequestData>();
+
+            // 結合フラグが結合（親）以外の場合
+            if (m_BaseConstructionBaseInfo.JoinFlg != 1)
             {
-                lblStatus.Text = "請求完了";
-                lblStatus.BackColor = Color.Blue;
-                lblStatus.ForeColor = Color.White;
+                // 単独、結合（子）は、請求工事＝本工事
+                lstConstructionCode.Add(m_ConstructionCode);
+
             }
-            // 状態フラグが9(請求準備)が存在すれば
-            else if(m_DicConstProgressDate.ContainsKey(9))
+            else
             {
-                lblStatus.Text = "請求準備";
-                lblStatus.BackColor = Color.GreenYellow;
-                lblStatus.ForeColor = Color.Black;
+                // リンク種別が結合子の工事で検索
+                GetConstructionLink(m_ConstructionCode, 1, ref lstConstructionCode);
             }
-            // その他
-            else
+
+            foreach (int nConstructionCode in lstConstructionCode)
             {
-                lblStatus.Text = "";
-                lblStatus.BackColor = Color.Black;
-                lblStatus.ForeColor = Color.White;
+                RequestData data = new RequestData();
+
+                ConstructionBaseInfo info = new ConstructionBaseInfo();
+                Dictionary<int, string> dic = new Dictionary<int, string>();
+
+                string str;
+
+                GetConstructionBaseInfo(nConstructionCode, ref info);
+                AddConstructionBaseInfo(nConstructionCode, info);
+
+                GetConstructionBaseInfoDetail(nConstructionCode, ref dic);
+
+                // 請求Noは登録時に決定
+                data.MainConstructionCode = nConstructionCode;      // 本工事番号
+
+                // 工事件名
+                dic.TryGetValue((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName, out str);
+                data.ConstructionName = str;
+
+                dicData.Add(nConstructionCode, data);
             }
 
+            m_lstRequestData.Add(dicData);
         }
+        #endregion
 
-        /// <summary>
-        /// 本工事行表示設定
-        /// </summary>
-        /// <param name="m_HtConstructionDetail"></param>
-        /// <param name="m_ConstructionLedger"></param>
-        private void SetOriginalConstructionInfo()
+        #region 請求データ明細の生成
+        private void CreateRequestDataDetail()
         {
-            try
+            RequestDataDetail data;
+
+            Dictionary<int, RequestData> dicData = m_lstRequestData[0];
+
+            Dictionary<int, List<RequestDataDetail>> dicDetail = new Dictionary<int, List<RequestDataDetail>>();
+
+            List<int> lstKey = new List<int>(dicData.Keys);
+
+            foreach (int nMainConstructionCode in lstKey)
             {
-                var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.BillPrice);
-                var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.TaxPrice);
-                var gridRowAmount = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice);
+                string str;
 
-                // 工事金額の消費税額を計算
-                double constructionTaxPrice = Math.Truncate(m_ConstructionLedger.OrdersDecisionPrice * m_TaxRate);
+                List<RequestDataDetail> lstDetail = new List<RequestDataDetail>();
 
-                int cIndex;
+                List<int> lstWork = new List<int>();
 
-                // 工事番号
-                cIndex = GetColumnIndexNum(ColumnIndex.ConstructionCode);
-                gridRowBillPrice.Cells[cIndex].Value = m_ConstructionCode;
-                gridRowTaxPrice.Cells[cIndex].Value = m_ConstructionCode;
-                gridRowAmount.Cells[cIndex].Value = m_ConstructionCode;
+                data = new RequestDataDetail();
 
-                // 工事名
-                cIndex = GetColumnIndexNum(ColumnIndex.ConstructionName);
-                gridRowBillPrice.Cells[cIndex].Value = m_DicConstructionDetail[(int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName];
+                // 請求Noは登録時に裁判
+                data.MainConstructionCode = nMainConstructionCode;          // 本工事番号
+                data.ConstructionCode = nMainConstructionCode;              // 工事番号
+                data.ConstructionKind = 0;                                  // 工事区分(=本工事)
 
-                // 工事金額
-                cIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
-                SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], m_ConstructionLedger.OrdersDecisionPrice);
-                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], constructionTaxPrice);
+                lstDetail.Add(data);
 
+                // 増減工事の取得
+                GetConstructionLink(nMainConstructionCode, 0, ref lstWork);
+
+                foreach (int nConstructionCode in lstWork)
+                {
+                    ConstructionBaseInfo info = new ConstructionBaseInfo();
+                    GetConstructionBaseInfo(nConstructionCode, ref info);
+                    AddConstructionBaseInfo(nConstructionCode, info);
+
+                    data = new RequestDataDetail();
+
+                    // 請求Noは登録時に裁判
+                    data.MainConstructionCode = nMainConstructionCode;          // 本工事番号
+                    data.ConstructionCode = nConstructionCode;                  // 工事番号
+                    data.ConstructionKind = 1;                                  // 工事区分(=増減工事)
+
+                    Dictionary<int, string> dicString = new Dictionary<int, string>();
+                    GetConstructionBaseInfoDetail(nConstructionCode, ref dicString);
+
+                    dicString.TryGetValue((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName, out str);
+                    AddConstructionString(nConstructionCode, str);
+
+                    lstDetail.Add(data);
+                }
+
+                dicDetail.Add(nMainConstructionCode, lstDetail);
             }
-            catch (Exception ex)
+
+            m_lstRequestDataDetail.Add(dicDetail);
+
+            return;
+        }
+        #endregion
+
+        #endregion
+
+        #region 設定系メソッド
+
+        #region 表示データの設定
+        private void SetRequestDispData()
+        {
+            this.dgv1.CellBeginEdit -= dgv1_CellBeginEdit;
+            this.dgv1.CellFormatting -= this.dgv1_CellFormatting;
+
+            RequestHead ReqHead = m_lstRequestHead[m_nMaxOrderNo - 1];
+
+            // 請求先名
+            txtOrderer.Text = ReqHead.OrderersName;
+
+            // 編集可かつ請求書データに紐づかない場合のみ編集可能
+            if ((m_bEdit == true) && (ReqHead.InvoiceNo == 0))
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                txtOrderer.ReadOnly = false;
             }
 
+            // 回目
+            lblReqOrder.Text = string.Format("{0}回目", m_nMaxOrderNo);
+
+            // 請求件名
+            dgv1[4, 0].Value = ReqHead.ReqConstructionName.Trim();
+
+            dgv1[4, 0].ReadOnly = (m_bEdit == true ? (false) : (true));                // 請求件名は編集可能
+            dgv1[2, 0].Value = m_ConstructionCode.ToString();
+
+            // ボディ部の設定
+            SetRequestDispDataBody();
+
+            // 受付回数毎の設定
+            SetRequestDispDataOrder();
+
+            // ヘッダ部の設定
+            SetRequestDispDataHead();
+
+            // フッタ部の設定
+            SetRequestDispDataFooter();
+
+
+            this.dgv1.CellBeginEdit += dgv1_CellBeginEdit;
+            this.dgv1.CellFormatting += this.dgv1_CellFormatting;
+
+            return;
         }
+        #endregion
 
-        /// <summary>
-        /// 入金情報行表示設定
-        /// </summary>
-        /// <param name="m_HtRequestDataDetail"></param>
-        /// <param name="m_HtDepositDataDetail"></param>
-        private void SetDepositInfo ()
+        #region ヘッダ部の設定
+        private void SetRequestDispDataHead()
         {
-            try
+            int tcol = 5;
+            int trow = 6;
+
+            int nAmount = 0;
+            int nPriceTotal = 0;
+            int nTaxTotal = 0;
+
+            while (true)
             {
-                var gridPrice = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositPrice);
-                var gridDiff = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DifferencePrice);
+                if (dgv1[2, trow].Value == null)
+                {
+                    break;
+                }
 
-                int cIndex;
-                double totalDeposit = 0;
-                double totalDiff = 0;
+                nAmount = CommonMotions.cnvInt(dgv1[tcol, trow].Value);
+                nPriceTotal += nAmount;
 
-                // 合計値を計算
-                foreach (var detail in m_LstRequestTotalData)
+                nAmount = CommonMotions.cnvInt(dgv1[tcol, trow+1].Value);
+                nTaxTotal += nAmount;
+
+                trow += 2;
+            }
+
+            setAmount(tcol, 2, nPriceTotal + nTaxTotal);
+            setAmount(tcol, 3, nPriceTotal);
+            setAmount(tcol, 4, nTaxTotal);
+
+
+            for (int i = 0; i < m_nMaxOrderNo; i++)
+            {
+                trow = 6 ; 
+                tcol = 8+i;
+                nPriceTotal = 0;
+                nTaxTotal = 0;
+
+                int nState = m_lstOrderState[i];
+
+                RequestHead ReqHead = m_lstRequestHead[i];
+
+                setAmount(tcol, 5, ReqHead.UnpaidAmount);
+
+                // 最終承認済ではない場合は未入金行は編集可
+                if (m_lstOrderState[i] != (int)ApprovalState.End)
                 {
-                    if (m_DicDepositDataDetail.ContainsKey(detail.OrderNo))
+                    dgv1[tcol, 5].ReadOnly = (m_bEdit == true ? (false):(true));    
+                }
+
+                while (true)
+                {
+                    if (dgv1[2, trow].Value == null)
                     {
-                        var depDetail = m_DicDepositDataDetail[detail.OrderNo];
-                        totalDeposit += depDetail.DepositAmount;
-                        totalDiff += depDetail.CarryAmount;
+                        break;
                     }
+
+                    nAmount = CommonMotions.cnvInt(dgv1[tcol, trow].Value);
+                    nPriceTotal += nAmount;
+
+                    nAmount = CommonMotions.cnvInt(dgv1[tcol, trow + 1].Value);
+                    nTaxTotal += nAmount;
+
+                    // 承認が最終承認済ではない場合
+                    if (nState != (int)ApprovalState.End)
+                    {
+                        dgv1[tcol, trow].ReadOnly = (m_bEdit == true ? (false) : (true));
+                        dgv1[tcol, trow + 1].ReadOnly = (m_bEdit == true ? (false) : (true));
+                    }
+
+                    trow += 2;
                 }
 
-                // 工事金額総計を計算
-                double totalOrderDecisionPrice = m_ConstructionLedger.OrdersDecisionPrice;
-                foreach (int constCode in m_LstConstructionLink)
+                setAmount(tcol, 2, nPriceTotal + nTaxTotal);
+                setAmount(tcol, 3, nPriceTotal);
+                setAmount(tcol, 4, nTaxTotal);                
+
+            }
+        }
+        #endregion
+
+        #region ボディ部の設定
+        private void SetRequestDispDataBody()
+        {
+            int trow = 6;
+            int nAmount;
+
+            Dictionary<int, RequestData> dicData = m_lstRequestData[m_nMaxOrderNo - 1];
+            Dictionary<int, List<RequestDataDetail>> dicDetail = m_lstRequestDataDetail[m_nMaxOrderNo - 1];
+
+            List<int> lstKey = new List<int>(dicDetail.Keys);
+            
+            foreach( int nConstructionCode in lstKey )
+            {
+                List<RequestDataDetail> lst = null;
+                if (dicDetail.TryGetValue(nConstructionCode, out lst) == false)
                 {
-                    totalOrderDecisionPrice += m_DicChldConstructionLedger[constCode].OrdersDecisionPrice;
+                    return;
                 }
 
-                // 合計列
-                cIndex = GetColumnIndexNum(ColumnIndex.Total);
-                SetDataGridCellDecimal(gridPrice.Cells[cIndex], totalDeposit);
-                SetDataGridCellDecimal(gridDiff.Cells[cIndex], totalDiff);
+                // 請求データを取得しておく
+                RequestData ReqData = null;
+                if (dicData.TryGetValue(lst[0].MainConstructionCode, out ReqData) == false)
+                {
+                    return;
+                }
 
-                // 残り列
-                cIndex = GetColumnIndexNum(ColumnIndex.Amount);
-                double amountDeposit = totalOrderDecisionPrice * (m_TaxRate + 1) - totalDeposit + totalDiff;
-                SetDataGridCellDecimal(gridPrice.Cells[cIndex], amountDeposit);
-                SetDataGridCellDecimal(gridDiff.Cells[cIndex], -totalDiff);
+                foreach (RequestDataDetail ReqDetail in lst)
+                {
+                    ConstructionBaseInfo inf = null;
+                    if (m_dicConstructionBaseInfo.TryGetValue(ReqDetail.ConstructionCode, out inf) == false)
+                    {
+                        return;
+                    }
+
+                    // 本工事の場合
+                    if (ReqDetail.ConstructionKind == 0)
+                    {
+                        // 工事件名は、請求データから（編集可）
+                        dgv1[4, trow].Value = ReqData.ConstructionName;
+                        dgv1[4, trow].ReadOnly = false;
+                        dgv1[3, trow].Value = "本工事";
+                        dgv1[1, trow].Value = ((int)dgvKind.BodyMainConstruction).ToString();
+                        dgv1[dgv1.ColumnCount - 1, trow].Value = ReqData.Note;
+                        dgv1[dgv1.ColumnCount - 1, trow].ReadOnly = (m_bEdit == true ? (false) : (true));
+
+                    }
+                    else
+                    {
+                        string str;
+
+                        // 工事件名は、退避した工事件名から（編集不可）
+                        m_dicConstructionName.TryGetValue(ReqDetail.ConstructionCode, out str);
+                        dgv1[4, trow].Value = str;
+                        dgv1[3, trow].Value = "増減工事";
+                        dgv1[1, trow].Value = ((int)dgvKind.BodySubConstruction).ToString();
+                    }
+
+                    dgv1[2,trow].Value = ReqDetail.ConstructionCode;
+                    dgv1[6, trow].Value = "請求金額";
+                    dgv1[6, trow + 1].Value = "消費税";
+                    dgv1[1, trow + 1].Value = ((int)dgvKind.Body).ToString();
+
+                    dgv1[6, trow].Style.ForeColor = Color.Black;
+                    dgv1[6, trow+1].Style.ForeColor = Color.Black;
+
+                    if (trow > 13)
+                    {
+                        dgv1.Rows[trow].Visible = true;
+                        dgv1.Rows[trow+1].Visible = true;
+                    }
+
+                    // 税抜受注決定金額
+                    nAmount = CommonMotions.IntRoundDown(inf.OrdersDecisionPrice, 0);
+                    setAmount(5, trow, nAmount);
+
+                    // 消費税
+                    nAmount = CommonMotions.IntRoundDown(inf.OrdersDecisionPriceInTax - inf.OrdersDecisionPrice, 0);
+                    setAmount(5, trow + 1, nAmount);
+
+                    m_nMaxRowNo = trow + 1;
+
+                    trow += 2;
+                }
             }
-            catch (Exception ex)
+
+        }
+        #endregion
+
+        #region フッタ部の設定
+        private void SetRequestDispDataFooter()
+        {
+            int i;
+
+            int trow = 30;
+
+            int nTotalAmount = 0;
+            int nDepositAmount = 0;
+            int nGapAmount = 0;
+
+            for (i = 0; i < m_lstRequestHead.Count; i++)
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                int tcol = i + 8;
+
+                DepositDataDetail DepDetail = m_lstDepDataDetail[i];
+                RequestHead ReqHead = m_lstRequestHead[i];
+
+                // 空データはスルー
+                if (DepDetail.TargetDate == string.Empty)
+                {
+                    continue;
+                }
+
+                dgv1[tcol, trow].Value = m_lstDepositDate[i].ToString("yyyy/MM/dd");
+
+                nDepositAmount += DepDetail.DepositAmount;
+                nGapAmount += (DepDetail.DepositAmount - ReqHead.RequestTotalAmount);
+
+                setAmount(tcol, trow + 1, DepDetail.DepositAmount);
+                setAmount(tcol, trow + 2, DepDetail.DepositAmount - ReqHead.RequestTotalAmount);
+
+                if (m_lstDepositState[i] == (int)DepositState.Done)
+                {
+                    dgv1[tcol, trow + 3].Value = "確認済";
+                }
             }
+
+            setAmount(7, trow + 1, nDepositAmount);
+            setAmount(7, trow + 2, nGapAmount);
+
+            nTotalAmount = GetTotalRequestAmount();
+            setAmount(dgv1.ColumnCount - 2, trow + 1, nTotalAmount - nDepositAmount);
+            setAmount(dgv1.ColumnCount - 2, trow + 2, -nGapAmount);
+
         }
+        #endregion
 
-        /// <summary>
-        /// 増減工事行表示設定
-        /// </summary>
-        /// <param name="m_LstChldContructionData"></param>
-        /// <param name="m_HtChldConstructionDetail"></param>
-        private void SetChildConstructionInfo()
+        #region 請求金額合計の取得
+        private int GetTotalRequestAmount()
         {
-            try
+            int i;
+            int RequestAmount = 0;
+
+            for (i = 0; i < m_nMaxOrderNo; i++)
             {
-                int cIndex;
+                int nState = m_lstOrderState[i];
 
-                // 増減工事の数分繰り返し
-                foreach (var info in m_LstChldContructionData)
+                if (nState == (int)ApprovalState.End)
                 {
-                    int rowIndex = m_LstChldContructionData.IndexOf(info);
+                    RequestHead ReqHead = m_lstRequestHead[i];
+                    RequestAmount += (ReqHead.RequestAmount + ReqHead.TaxAmount);
+                }
+            }
+            return RequestAmount;
+        }
+        #endregion
 
-                    if (m_ChildConstructionRowCount <= rowIndex)
+        #region 請求回目のデータ設定
+        private void SetRequestDispDataOrder()
+        {
+
+            for (int i = 0; i < m_nMaxOrderNo; i++)
+            {
+                int tcol = i + 8;
+                int trow = 6;
+                int nState = (int)ApprovalState.Entry;
+
+                Dictionary<int, List<RequestDataDetail>> dic = m_lstRequestDataDetail[i];
+
+                RequestHead ReqHead = m_lstRequestHead[i];
+
+                dgv1.Columns[tcol].HeaderCell.Style.ForeColor = Color.Black;
+
+                // 既に１度以上ＤＢに登録されている
+                if (ReqHead.RequestNo > 0)
+                {
+                    nState = GetApprovalState(ReqHead.ReqConstructionCode, ReqHead.OrderNo);
+
+                    // 請求月と承認状態の設定
+                    SetRequestMonthAndApprovalState(ReqHead.OrderNo, ReqHead.RequestMonth, nState);
+
+                }
+                else
+                {
+                    // 請求月と承認状態の設定
+                    SetRequestMonthAndApprovalState(i+1, 0, nState);
+                }
+
+                m_lstOrderState.Add(nState);
+
+                while(true){
+                    if (dgv1[2, trow].Value == null)
                     {
-                        // 増減工事行が足りない場合は行を追加
-                        AddChildConstructionInfoRow(rowIndex);
+                        break;
                     }
 
-                    var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.BillPrice, rowIndex);
-                    var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, rowIndex);
+                    string str = dgv1[2, trow].Value.ToString();
 
-                    // 各行の文字色を設定
-                    gridRowBillPrice.DefaultCellStyle.ForeColor = Color.Black;
-                    gridRowTaxPrice.DefaultCellStyle.ForeColor = Color.Black;
+                    int key = int.Parse(str);
 
-                    // 工事番号
-                    cIndex = GetColumnIndexNum(ColumnIndex.ConstructionCode);
-                    gridRowBillPrice.Cells[cIndex].Value = info.ConstructionCode;
-                    gridRowTaxPrice.Cells[cIndex].Value = info.ConstructionCode;
+                    List<RequestDataDetail> lst = null;
 
-                    if (m_DicChldConstructionDetail.ContainsKey(info.ConstructionCode))
+                    dic.TryGetValue(key, out lst);
+
+                    for (int j = 0; j < lst.Count; j++)
                     {
-                        var detail = m_DicChldConstructionDetail[info.ConstructionCode] as Dictionary<int,string>;
+                        setAmount(tcol, trow, lst[j].RequestAmount);
+                        setAmount(tcol, trow + 1, lst[j].TaxAmount);
 
-                        // 工事名
-                        if (detail.ContainsKey((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName))
+                        if (nState == (int)ApprovalState.Entry)
                         {
-                            cIndex = GetColumnIndexNum(ColumnIndex.ConstructionName);
-                            gridRowBillPrice.Cells[cIndex].Value = detail[(int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName] as string;
+                            dgv1[tcol, trow].ReadOnly = (m_bEdit == true ? (false):(true));
+                            dgv1[tcol, trow + 1].ReadOnly = (m_bEdit == true ? (false) : (true));
                         }
-
+                        trow += 2;
                     }
 
-                    // 工事金額
-                    cIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
-                    double ordersDecisionPrice = 0;
-                    double taxPrice = 0;
-                    if (m_DicChldConstructionLedger.ContainsKey(info.ConstructionCode))
-                    {
-                        var ledger = m_DicChldConstructionLedger[info.ConstructionCode] as ConstructionLedger;
-                        ordersDecisionPrice = ledger.OrdersDecisionPrice;
-                        taxPrice = Math.Truncate(ledger.OrdersDecisionPrice * m_TaxRate);
-                    }
-                    SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], ordersDecisionPrice);
-                    SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], taxPrice);
-
                 }
             }
-            catch (Exception ex)
+        }
+        #endregion
+
+        #region 請求月および申請状況の設定
+        private void SetRequestMonthAndApprovalState(int nOrderNo, int nRequestMonth, int nState)
+        {
+            string[] StateString = new string[] { "入力中", "申請中", "承認中", "保留", "不承認", "承認済" };
+
+            int tcol = nOrderNo + 7;
+
+            if (nState == (int)ApprovalState.Entry)
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                dgv1[tcol, 0].Value = StateString[nState];
+                dgv1[tcol, 0].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+
+                dgv1[tcol, 1].Value = "";
             }
+            else
+            {
+                if (nRequestMonth > 0)
+                {
+                    int yyyy = CommonMotions.cnvTruncate((double)nRequestMonth / 100);
+                    int mm = nRequestMonth % 100;
+                    dgv1[tcol, 0].Value = string.Format("{0}/{1}", yyyy, mm);
+                    dgv1[tcol, 0].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                }
+
+                dgv1[tcol, 1].Value = StateString[nState];
+                dgv1[tcol, 1].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+            }
         }
+        #endregion
 
-        /// <summary>
-        /// 本工事セクションおよび増減工事セクションの、すべての自動計算カラムを計算する
-        /// </summary>
-        private void SetAutoCalcRow()
+        #region 請求月コンボの設定
+        private void SetRequestMonth()
         {
-            try
+            int yyyymm;
+            int nState;
+            int now_yyyymm;
+
+            int key;
+            string val;
+            KeyValuePair<int, string> keyval;
+            RequestHead ReqHead;
+
+            yyyymm = 0;
+            now_yyyymm = 0;
+
+            for (int i = m_nMaxOrderNo-1; i>=0; i--)
             {
-                // 本工事セクション
-                if (m_DicRequestDataDetail.ContainsKey(m_ConstructionCode))
+                // 請求ヘッダの取得
+                ReqHead = m_lstRequestHead[i];
+
+                // 受付状態を取得
+                nState = m_lstOrderState[i];
+
+                // 最終承認済以外は対象外
+                if(nState != (int)ApprovalState.End){
+                    continue;
+                }
+
+                if (yyyymm < ReqHead.RequestMonth)
                 {
-                    foreach (RowKind kind in s_HtRowSections[RowSectionIndex.OriginalConstruction])
-                    {
-                        var gridRow = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, kind);
-                        SetAutoCalcCell(gridRow);
+                    yyyymm = ReqHead.RequestMonth;
+                    break;
+                }
+            }
 
-                    }
+            DateTime dt = DateTime.Today;
+            List<KeyValuePair<int, string>> lst = new List<KeyValuePair<int, string>>();
+
+            // 先月から3カ月後まで
+            for (int i = -1; i < 4; i++)
+            {
+                DateTime wk = dt.AddMonths(i);
+
+                key = int.Parse(wk.ToString("yyyyMM"));
+
+                if(i==0)
+                {
+                    now_yyyymm = key;
                 }
 
-                // 増減工事セクション
-                foreach (int constCode in m_LstConstructionLink)
+                // 最終承認済の請求月以上の年月だけ追加
+                if (key >= yyyymm)
                 {
-                    foreach (RowKind kind in s_HtRowSections[RowSectionIndex.ChildConstruction])
-                    {
-                        var gridRow = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, kind, m_LstConstructionLink.IndexOf(constCode));
-                        SetAutoCalcCell(gridRow);
-                    }
+                    val = wk.ToString("yyyy/MM");
+
+                    keyval = new KeyValuePair<int, string>(key, val);
+
+                    lst.Add(keyval);
                 }
             }
-            catch (Exception ex)
+
+            cbReqMonth.ValueMember = "Key";
+            cbReqMonth.DisplayMember = "Value";
+
+            // コンボボックス初期表示
+            ComboBoxAction.InitDataSetCombBox(cbReqMonth, lst, false);
+
+            // 最新の請求ヘッダ、受付状態の取得
+            ReqHead = m_lstRequestHead[m_nMaxOrderNo-1];
+            nState = m_lstOrderState[m_nMaxOrderNo-1];
+
+            if (ReqHead.RequestNo != 0)
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                cbReqMonth.SelectedValue = ReqHead.RequestMonth;
             }
+            else
+            {
+                cbReqMonth.SelectedValue = now_yyyymm;
+            }
+
+            // 直近受付が最終承認済の場合
+            if (nState == (int)ApprovalState.End)
+            {
+                // 請求年月は変更不可
+                cbReqMonth.Enabled = false;
+            }
+
         }
+        #endregion
 
-        /// <summary>
-        /// 指定行の自動計算カラムを計算する
-        /// </summary>
-        /// <param name="row"></param>
-        private void SetAutoCalcCell(DataGridViewRow row)
+        #region 申請状態の取得
+        private int GetApprovalState(int nConstructionCode, int nOrderNo)
         {
-            try
+            int nState = (int)ApprovalState.Entry;
+
+            List<ProcessApproval> lst = null;
+
+            if (m_dicProcessApproval.TryGetValue(nOrderNo, out lst) == false)
             {
-                var sectionIndex = (RowSectionIndex)row.Cells[GetColumnIndexNum(ColumnIndex.SectionIndex)].Value;
-                var rowKind = (RowKind)row.Cells[GetColumnIndexNum(ColumnIndex.RowKind)].Value;
-                var constCode = (int)row.Cells[GetColumnIndexNum(ColumnIndex.ConstructionCode)].Value;
+                return nState;
+            }
 
-                if (m_DicRequestDataDetail.ContainsKey(constCode))
+            for (int i = 0; i < lst.Count; i++)
+            {
+                ProcessApproval pap = lst[i];
+
+                if (pap.SeqNo == 1)
                 {
-                    double total = 0;
-                    foreach (var orderNo in m_DicRequestDataDetail[constCode].Keys)
-                    {
-                        int colIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, orderNo);
-                        switch (rowKind)
-                        {
-                            case RowKind.BillPrice:
-                                m_DicRequestDataDetail[constCode][orderNo].BillPrice = Convert.ToInt32(row.Cells[colIndex].Value);
-                                total += m_DicRequestDataDetail[constCode][orderNo].BillPrice;
-                                break;
-                            case RowKind.TaxPrice:
-                                m_DicRequestDataDetail[constCode][orderNo].TaxPrice = Convert.ToInt32(row.Cells[colIndex].Value);
-                                total += m_DicRequestDataDetail[constCode][orderNo].TaxPrice;
-                                break;
-                            case RowKind.AmountPrice:
-                                m_DicRequestDataDetail[constCode][orderNo].AmountBlance = Convert.ToInt32(row.Cells[colIndex].Value);
-                                total += m_DicRequestDataDetail[constCode][orderNo].AmountBlance;
-                                break;
-                            default:
-                                break;
-                        }
+                    if( nState < (int)ApprovalState.Apply){
+                        nState = (int)ApprovalState.Apply;  
                     }
+                    continue;
+                }
 
-                    // 合計列
-                    int totalColIndex = GetColumnIndexNum(ColumnIndex.Total);
-                    SetDataGridCellDecimal(row.Cells[totalColIndex], total);
+                ApprovalMaster apm = new ApprovalMaster();
+                m_dicApprovalMaster.TryGetValue(pap.PersonCode, out apm);
 
-                    // 残り列
-                    int amountColIndex = GetColumnIndexNum(ColumnIndex.Amount);
-                    if (rowKind != RowKind.AmountPrice)
+                // 保留の場合
+                if (pap.ApprovalStatus == 1)
+                {
+                    if (nState < (int)ApprovalState.Pending)
                     {
-                        // 未入金分以外
-                        // 工事金額を取得
-                        int constPriceColIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
-                        double constPrice = Convert.ToDouble(row.Cells[constPriceColIndex].Value ?? 0);
+                        nState = (int)ApprovalState.Pending;
+                    }
+                    continue;
+                }
 
-                        // 残り列に残り金額をセット
-                        SetDataGridCellDecimal(row.Cells[amountColIndex], constPrice - total);
+                // 承認の場合
+                if (pap.ApprovalStatus == 2)
+                {
+                    // 最終権限者の場合
+                    if (apm.ApprovalAuthority == 1)
+                    {
+                        // 承認済確定
+                        nState = (int)ApprovalState.End;
+
+                        // 最終承認者の承認があれば他は見なくてよい。
+                        break;
+
                     }
                     else
                     {
-                        var gridRowDiff = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DifferencePrice);
-                        double diffPrice = Convert.ToDouble(gridRowDiff.Cells[totalColIndex].Value ?? 0);
+                        if (nState < (int)ApprovalState.Approval)
+                        {
+                            nState = (int)ApprovalState.Approval;
+                        }
+                    }
+                    continue;
+                }
 
-                        // 残り列に未入金残り金額をセット
-                        SetDataGridCellDecimal(row.Cells[amountColIndex], diffPrice - total);
-
+                // 非承認の場合
+                if (pap.ApprovalStatus == 3)
+                {
+                    if (nState < (int)ApprovalState.Dismissal)
+                    {
+                        nState = (int)ApprovalState.Dismissal;
                     }
+                    continue;
                 }
+
             }
-            catch (Exception ex)
+            return nState;
+        }
+        #endregion
+
+        #region [回数追加]ボタンの有効無効判定
+        private bool GetbtnAddEnabled()
+        {
+            // 編集可能でない場合
+            if (m_bEdit == false)
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
             }
+
+            // 入金が完了している場合
+            if (m_ConstructionLedger.ComplateFlg == 1)
+            {
+                return false;
+            }
+
+            // 直近の状態が承認完了以外の場合
+            if (m_lstOrderState[m_nMaxOrderNo - 1] != (int)ApprovalState.End)
+            {
+                return false;
+            }
+
+            // 分割払いの場合
+            if (m_BaseConstructionBaseInfo.BillingSplitFlg == 1)
+            {
+
+                return true;
+            }
+            
+            return false;
         }
+        #endregion
 
-        /// <summary>
-        /// 合計セクション表示設定
-        /// </summary>
-        private void SetTotalInfo()
+        #region 数値編集可能セル判定
+        private bool isEditNumCell(int tcol, int trow)
         {
-            try
+
+            bool ret = false;
+
+            // 編集回目であることかつ未入金分～最大工事の消費税まで
+            if ((tcol == m_nMaxOrderNo + 7)&&((trow >= 6 )&&( trow <=  m_nMaxRowNo )))
             {
-                // 工事金額列
-                SetTotalInfoColumn(ColumnIndex.ConstructionPrice);
+                return true;
+            }
+            return ret;
+        }
+        #endregion
 
-                // 請求回数分繰り返し
-                foreach (var record in m_LstRequestTotalData)
+        #region 編集タイプの取得
+        private int GetEditType(int tcol, int trow)
+        {
+            int ret = (int)EditType.NotEdit;
+
+            // 列チェック（工事名と対象回目以外、コメント以外の列は編集対象外
+            if ((tcol != 4)&&( tcol != m_nMaxOrderNo + 7)&&(tcol != dgv1.ColumnCount-1)) 
+            {
+                return ret;
+            }
+
+            // 請求件名は対象
+            if ((tcol == 4) && (trow == 0))
+            {
+                return (int)EditType.Name;
+            }
+
+            // 列が対象回目かつ行が未入金分～最大行まで
+            if(( tcol == m_nMaxOrderNo + 7)&&(( trow >= 5 )&&( trow <= m_nMaxRowNo)))
+            {
+                return (int)EditType.Amount;
+            }
+
+            if(( tcol == 4 )||(tcol == dgv1.ColumnCount-1))
+            {
+                if (dgv1[3, trow].Value == null)
                 {
-                    // 請求明細列
-                    SetTotalInfoColumn(ColumnIndex.RequestInfo, m_LstRequestTotalData.IndexOf(record) + 1);
+                    return ret;
                 }
 
-                SetTotalSectionInfo();
+                if (int.Parse(dgv1[1, trow].Value.ToString()) == (int)dgvKind.BodyMainConstruction)
+                {
+                    return (int)EditType.Name;
+                }
+                else
+                {
+                    return ret;
+                }
             }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-            }
+
+            return ret;
         }
+        #endregion
 
+
+        #endregion
+
+        #region 請求回数追加関連
+
+        #region 請求回数追加
         /// <summary>
-        /// 合計セクションの合計および残り列表示設定
+        /// 請求回数追加
         /// </summary>
-        private void SetTotalSectionInfo()
+        private void AddRequest()
         {
+            int tcol = 0;
+
+            if (m_nMaxOrderNo == 15)
+            {
+                return;
+            }
+
             try
             {
-                double totalBillPrice = 0;
-                double totalNonTaxedPrice = 0;
-                double totalTaxPrice = 0;
-                double totalAmount = 0;
+                tcol = m_nMaxOrderNo + 7;
 
-                var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
-                var gridRowNonTaxedPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.NonTaxedPrice);
-                var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.TaxPrice);
-                var gridRowAmount = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.AmountPrice);
+                for (int i = 5; i <= m_nMaxRowNo; i++)
+                {
+                    dgv1[tcol, i].ReadOnly = true;
+                }
 
-                int cIndex;
+                //// 請求回数を追加
+                AddRequestOrder();
 
-                // 請求回数分繰り返し
-                foreach (var record in m_LstRequestTotalData)
+                tcol = m_nMaxOrderNo + 7;
+
+                dgv1.Columns[tcol].Visible = true;
+
+                for (int i = 5; i <= m_nMaxRowNo; i++)
                 {
-                    // 合計計算
-                    cIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, m_LstRequestTotalData.IndexOf(record) + 1);
-                    totalBillPrice += Convert.ToDouble(gridRowBillPrice.Cells[cIndex].Value);
-                    totalNonTaxedPrice += Convert.ToDouble(gridRowNonTaxedPrice.Cells[cIndex].Value);
-                    totalTaxPrice += Convert.ToDouble(gridRowTaxPrice.Cells[cIndex].Value);
-                    totalAmount += Convert.ToDouble(gridRowAmount.Cells[cIndex].Value);
+                    dgv1[tcol, i].ReadOnly = (m_bEdit == true ? (false) : (true));
                 }
 
-                // 合計列
-                cIndex = GetColumnIndexNum(ColumnIndex.Total);
-                SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], totalBillPrice);
-                SetDataGridCellDecimal(gridRowNonTaxedPrice.Cells[cIndex], totalNonTaxedPrice);
-                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], totalTaxPrice);
-                SetDataGridCellDecimal(gridRowAmount.Cells[cIndex], totalAmount);
+                m_lstOrderState.Add((int)ApprovalState.Entry);
+                dgv1[tcol, 0].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                dgv1[tcol, 0].Value = "入力中";
+                cbReqMonth.Enabled = (m_bEdit == true ? (true) : (false));
+                txtOrderer.ReadOnly = (m_bEdit == true ? (false) : (true));
 
-                // 残り列
-                int constPriceIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
-                cIndex = GetColumnIndexNum(ColumnIndex.Amount);
-                SetDataGridCellDecimal(gridRowNonTaxedPrice.Cells[cIndex], Convert.ToDouble(gridRowNonTaxedPrice.Cells[constPriceIndex].Value) - totalNonTaxedPrice);
-                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], Convert.ToDouble(gridRowTaxPrice.Cells[constPriceIndex].Value) - totalTaxPrice);
+                lblReqOrder.Text = string.Format("{0}回目", m_nMaxOrderNo);
 
-                double amountBalance = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice).Cells[cIndex].Value);
-                SetDataGridCellDecimal(gridRowAmount.Cells[cIndex], amountBalance);
-
+                dgv1.Refresh();
             }
             catch (Exception ex)
             {
